.TH transaction Onyx
.SH NAME
transactions.ppg \- grammar for Onyx-Transactions
.SH SYNOPSYIS
.nf
class Transactions : public Parser {
	RecDesc 	*field_d;
	Cursor  	*cursor_d;
	View		*mask_d;
	List		*field_l;
	char		*exp_v;
	char		*field_v;
	
	SqlParser	*sql_p;
	Shell		*shell_p;
	
	int		fetch_flag;
	
	Transactions();
	virtual ~Transactions();
	
	int statement();
	int grammar();
	
	int fieldid();
	int cursorid();
	int maskid();
	int fieldlist();
	
	int import();
	int export();
	int fetch();
	int sql();
	int controll();
	int call();
	int masks();
	
	int field();
	int expr();
	int set();
	
	int expand();
	int ExecSql();
	}
.fi
.SH IMPLEMENTATION
.PP
statement : 
.br
.in +0.8i
.ad l
.nh
import  | export  | call  | set  | masks  | sql  | fetch  | controll  
.br
;
.br
.hy
.PP
grammar : 
.br
.in +0.8i
.ad l
.nh
( eof  | statement  [ ";" ] ) 
.br
;
.br
.hy
.PP
fieldid : 
.br
.in +0.8i
.ad l
.nh
id  [ "." id  ] 
.br
;
.br
.hy
.PP
maskid : 
.br
.in +0.8i
.ad l
.nh
id  
.br
;
.br
.hy
.PP
cursorid : 
.br
.in +0.8i
.ad l
.nh
id  
.br
;
.br
.hy
.PP
fieldlist : 
.br
.in +0.8i
.ad l
.nh
( fieldid  ! "," ) 
.br
;
.br
.hy
.PP
import : 
.br
.in +0.8i
.ad l
.nh
"import" [ "current" ] cursorid  [ "(" fieldlist  ")" ] "from" [ "pipe" matchexp  expand  | "select" matchexp  expand  | "dynasel" | true  [ "file" ] matchexp  ] 
.br
;
.br
.hy
.PP
export : 
.br
.in +0.8i
.ad l
.nh
"export" [ "current" ] cursorid  [ "(" fieldlist  ")" ] "to" [ "pipe" matchexp  expand  | true  [ "file" | "append" ] matchexp  expand  ] 
.br
;
.br
.hy
.PP
call : 
.br
.in +0.8i
.ad l
.nh
"call" [ "shell" matchexp  expand  | true  id  ] 
.br
;
.br
.hy
.PP
masks : 
.br
.in +0.8i
.ad l
.nh
true  [ "show" maskid  | "hide" maskid  | "goto" maskid  matchexp  | true  ] 
.br
;
.br
.hy
.PP
field : 
.br
.in +0.8i
.ad l
.nh
"\(rs"" match  "\(rs"" | num  | "$" fieldid  | "`" match  expand  "`" | "(" expr  ")" 
.br
;
.br
.hy
.PP
expr : 
.br
.in +0.8i
.ad l
.nh
"case" fieldid  "in" ( field  ":" field  ! "," ) | "sum" "(" [ "new" | "valid" | "all" | true  ] cursorid  "." fieldid  ")" | field  ( "+" | "-" | "*" | "/" | true  ! true  field  ) 
.br
;
.br
.hy
.PP
set : 
.br
.in +0.8i
.ad l
.nh
"set" fieldid  "=" expr  
.br
;
.br
.hy
.PP
sql : 
.br
.in +0.8i
.ad l
.nh
true  [ "update" | "insert" | "delete" | true  ] matchexp  expand  
.br
;
.br
.hy
.PP
fetch : 
.br
.in +0.8i
.ad l
.nh
"fetch" [ "first" | "last" | "prior" | "prev" | "next" | "new" ] cursorid  [ "where" [ "not" ] fieldid  [ "=" fieldid  ] | true  ] | "clean" [ "current" ] cursorid  
.br
;
.br
.hy
.PP
controll : 
.br
.in +0.8i
.ad l
.nh
"validate" cursorid  | "for" [ "new" | "valid" | "all" ] cursorid  "do" id  | "if" [ "not" ] [ fetch  | "valid" cursorid  | "new" cursorid  | true  fieldid  [ "=" fieldid  ] ] | "break" ( ";" ! eof  | matchexp  ) | true  [ "then" | "and" | "else" | true  ] 
.br
;
.br
.hy
